#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <limits.h>
#include <assert.h>

struct elem_s {
  char l;
  int tl;
  int tr;
} typedef elem;

int tpos, pos, llen;
elem t[300];
char l[300];


int expr()
{
  int leftroot, tmproot, oldleftroot, oldpos, oldtpos;
  char c;
  
  leftroot=-1;

  while (pos<llen)
  {
    oldpos=pos;
    oldtpos=tpos;
    oldleftroot=leftroot;

    c=l[pos++];
/*    printf("pos=%d char=%c llen=%d leftroot=%d\n", pos, c, llen, leftroot);
*/    
    if (c=='(')
      tmproot=expr();
    else if (c==')')
      return leftroot;
    else
    {
      tmproot=tpos++;
      t[tmproot].l=c;
    }
    if (leftroot==-1)
      leftroot=tmproot;
    else
      t[leftroot].tr=tmproot;
    
    if (pos<llen)
    {
      c=l[pos++];
      if (c==')')
        return leftroot;
    
      tmproot=tpos++;
      t[tmproot].l=c;
      t[tmproot].tl=leftroot;
      if ((c=='*' || c=='/') && (t[leftroot].l=='+' || t[leftroot].l=='-'))
      {
        pos=oldpos;
	tpos=oldtpos;
	leftroot=oldleftroot;
        t[leftroot].tr=expr();
      }
      else
        leftroot=tmproot;
    }
  }
  
  return leftroot;
}

void printtree(int root)
{
  char c, c1;
  
  c=t[root].l;
  
/*  printf("root=%d char=%c\n", root, c);
*/  if (c=='+' || c=='-')
  {
    printtree(t[root].tl);
    putchar(c);
    c1=t[t[root].tr].l;
    if (c=='-' && (c1=='+' || c1=='-'))
    {
      putchar('(');
      printtree(t[root].tr);
      putchar(')');
    }
    else
      printtree(t[root].tr);
  }
  else if (c=='*' || c=='/')
  {
    c1=t[t[root].tl].l;
    if (c1=='+' || c1=='-')
    {
      putchar('(');
      printtree(t[root].tl);
      putchar(')');
    }
    else
      printtree(t[root].tl);
    
    putchar(c);
    c1=t[t[root].tr].l;
    if (c1=='+' || c1=='-' || (c=='/' && (c1=='*' || c1=='/')))
    {
      putchar('(');
      printtree(t[root].tr);
      putchar(')');
    }
    else
      printtree(t[root].tr);
  }
  else
    putchar(c);
}



int main()
{
  long ilosc_testow;
  int root;
  
  scanf("%ld\n", &ilosc_testow);
  for (; ilosc_testow; ilosc_testow--)
  {
    gets(l);
    pos=0;
    llen=strlen(l);
    tpos=0;
    root=expr();
    printtree(root);
    putchar('\n');
  }

  return 0;
}
